addpath('../matlab');

R = 287.04;
g = 9.80665;
fname = 'g974530024';
[sonde, plane, time, p, Ta, RH, dir, spd, lon, lat, z, zw] = readFRD(fname);
if any(isnan(z))  % Clean up nans
   fix = find(~isnan(z));
   time = time(fix); p = p(fix); Ta = Ta(fix); RH = RH(fix);
   dir = dir(fix); spd = spd(fix); lon = lon(fix); lat = lat(fix);
   z = z(fix); zw = zw(fix);
end
p = p*100; Ta = Ta + 273.15; 
q = 0.01*RH .* q_sat(Ta, p);
n = length(z);

Tv = Ta.*(1 + 0.608*q);

zhyd = zeros(n,1); zhydv = zeros(n,1);
zhyd(n) = z(n);  zhydv(n) = z(n);
for kk = n-1 : -1 : 1
   dlnp = log(p(kk) / p(kk+1));
   %dlnp = (p(kk) - p(kk+1))/(0.5*(p(kk) + p(kk+1)));
   Tbar = 0.5*(Ta(kk) + Ta(kk+1));
   Tvbar = 0.5*(Tv(kk) + Tv(kk+1));
   zhyd(kk)  = zhyd(kk+1)  - (R/g)*Tbar*dlnp;
   zhydv(kk) = zhydv(kk+1) - (R/g)*Tvbar*dlnp;
end

fig(1); clf;
plot([zhyd-z,zhydv-z],z); vline(0);

rho = p./(R*Tv); rho1 = 0.5*(rho(1:n-1) + rho(2:n));
delp = diff(p); delz = diff(z);
plot(delp + g*rho1.*delz, z(1:n-1));
