s0 = [0.1:0.1:5 6:1:50]';  % True speeds

sigv = 5;

nobs = 1000;

dbar = zeros(size(s0));
dsig = zeros(size(s0));

for is = 1 : length(s0)

   u0 = s0(is); 
   v0 = 0;

   u = u0 + sigv*randn(nobs,1);
   v = v0 + sigv*randn(nobs,1);

   d = atan2(v, u)*180/pi;
   dbar(is) = mean(d);
   dsig(is) = std(d);

end

fig(1); clf;
subplot(2,1,1); cla;
plot(s0, dsig, 'b-'); hold on;
plot(s0, (sigv*180/pi)./s0, 'r-');
ylim(0,50);
ylabel('\sigma_{dir} (degrees)');
xlabel('Wind speed (m/s)');
subplot(2,1,2); cla;
plot(s0, dsig, 'b-'); hold on;
plot(s0, (sigv*180/pi)./s0, 'r-');
xlim(0,5); ylim(0,150);
ylabel('\sigma_{dir} (degrees)');
xlabel('Wind speed (m/s)');


