function v = holland_v(beta,r,f)
% function v = holland_v(beta,r,f)
% Used for nonlinear fit in FitBogus

if (nargin <= 2), 
   global f0;
   f = f0; 
end;

b  = beta(1);
rm = beta(2);
pc = beta(3);
pe = beta(4);
dp = pe - pc;
rmrb = (rm./r).^b;

p = pc + dp*exp(-rmrb);
rho = p/(287*298);

v = sqrt( b*dp./rho .* exp(-rmrb) .* rmrb + (0.5*f*r).^2 ) - 0.5*f*r;
