% 
clear
a = [50 40e3 1.3 95000 298 1e3 -1e3 5 -3]';
dr = 2e2;
f = cor(15);
x = [0:dr:200e3]'; y = zeros(size(x)); t = [1 : length(x)]';
[p,dp] = holland_p_xyuv([x,y,t],a);
fig(1); clf;
subplot(3,3,1); cla; plot(x/1e3,p/1e2);
subplot(3,3,2); cla; plot(x/1e3,dp(:,1));
subplot(3,3,3); cla; plot(x/1e3,dp(:,2));
subplot(3,3,4); cla; plot(x/1e3,dp(:,3));
subplot(3,3,5); cla; plot(x/1e3,dp(:,4));
subplot(3,3,6); cla; plot(x/1e3,dp(:,5));
subplot(3,3,7); cla; plot(x/1e3,dp(:,6));
subplot(3,3,8); cla; plot(x/1e3,dp(:,7));
subplot(3,3,9); cla; plot(x/1e3,dp(:,8));

% Check derivatives
clear;
a = [30 30e3 1.3 95000 298 1e3 -1e3 5 -3]';
x = 4e3; y = 42e3; t = 10;
xyt = [ x, y, t ];
for ii = 1 : length(a)
   del = 1e-06; 
   a1 = a; a1(ii) = a1(ii)*(1 + del);
   [p1,dp1] = holland_p_xyuv(xyt,a1);
   a0 = a; a0(ii) = a0(ii)*(1 - del);
   [p0,dp0] = holland_p_xyuv(xyt,a0);
   [p2,dp2] = holland_p_xyuv(xyt,a);
   dp2a = (p1 - p0)/(a1(ii) - a0(ii));
   ok = abs(dp2a - dp2(:,ii)) < 1e-3*max(abs(dp2a), abs(dp2(:,ii)));
   disp(sprintf('%12.4e %12.4e %2d', dp2a, dp2(:,ii), ok));
end

% Test mrqmin fitting
clear;
ut = 5; vt = -3;
aa = [50,25e3,1.3,95000,298,0,0,ut,vt]'; na = length(aa);
f = cor(15);
r = 1e3*[1 3 20:1:30  80:4:100]'; nr = length(r);
%r = 1e3*[1 3 20:1:30  80:4:100 200:100:1000]'; nr = length(r);
lam = 2*pi*rand(nr,1);
t = 1e4*rand(nr,1);
x = r.*cos(lam) + ut*t; y = r.*sin(lam) + vt*t; xyt = [ x y t ];
sig = 200*ones(nr,1); 
rfit = 1e3*[1 : 120]'; drfit = rfit(2) - rfit(1);
ptrue = holland_p(rfit,aa);
penv = holland_p(1e6,aa);
vtrue = holland_v(rfit,aa,f);

nmc = 1;
amc = zeros(nmc,na);
chisq = zeros(nmc,1);
pomc = zeros(nmc,nr);
doplot = (nmc == 1);
for ii = 1 : nmc
   po = holland_p(r,aa) + sig.*randn(nr,1);
   pomc(ii,:) = po';
   a0 = aa .* [ 1.1 0.9 1.1 0.9 1 1.1 0.9 1.0 1.0 ]';
   ia = [ 1 1 1 1 0 1 1 1 1 ]';  % don't fit Tbar
   
   [a,cov,chisq(ii)] = mrqmin_multi(xyt, po, sig, a0, ia, 'holland_p_xyuv', 100, 10);

   amc(ii,:) = a';
   
   pfit = holland_p(rfit,amc(ii,:)');
   vfit = holland_v(rfit,amc(ii,:)',f);
   ro = hypot(x - a(5) - a(7)*t, y - a(6) - a(8)*t);
   
   if doplot
      fig(1); clf;
      subplot(3,1,1); cla;
      plot(ro/1e3,pomc(ii,:)/1e2,'bo'); hold on; xlim(0,120); ylim(940,1010);
      plot(rfit/1e3,pfit/1e2,'r');
      plot(rfit/1e3,ptrue/1e2,'g-');
      subplot(3,1,2); cla;
      plot(rfit/1e3,(pfit-ptrue)/1e2,'r'); hold on; xlim(0,120);
      subplot(3,1,3); cla;
      plot(rfit/1e3,vfit,'r'); hold on; xlim(0,120); ylim(0,60);
      plot(rfit/1e3,vtrue,'g-');     
      reltext(0.5,0.8,sprintf('vm true=%.1f fit=%.1f m/s',aa(1),amc(ii,1)));
   end
end

%save test_holland_p

bara = mean(amc); siga = std(amc);
astats = [ bara-siga ; bara ; bara+siga ];

fig(2); clf;
subplot(2,4,1); cla;
plot(amc(:,1),chisq,'o'); hold on; plot(astats(:,1),[0 0 0],'r*');
xlabel('vm'); vline(aa(1)); ylabel('\chi^2');
subplot(2,4,2); cla;
plot(amc(:,2)/1e3,chisq,'o'); hold on; plot(astats(:,2)/1e3,[0 0 0],'r*');
vline(aa(2)/1e3); xlabel('rm'); 
subplot(2,4,3); cla;
plot(amc(:,3),chisq,'o'); hold on; plot(astats(:,3),[0 0 0],'r*');
vline(aa(3)); xlabel('b'); 
subplot(2,4,4); cla;
plot(amc(:,4)/1e2,chisq,'o'); hold on; plot(astats(:,4)/1e2,[0 0 0],'r*');
vline(aa(4)/1e2); xlabel('pc'); 
subplot(2,4,5); cla;
plot(amc(:,5),chisq,'o'); hold on; plot(astats(:,5),[0 0 0],'r*');
vline(aa(5)); xlabel('delx'); ylabel('\chi^2');
subplot(2,4,6); cla;
plot(amc(:,6),chisq,'o'); hold on; plot(astats(:,6),[0 0 0],'r*');
vline(aa(6)); xlabel('dely');
subplot(2,4,7); cla;
plot(amc(:,7),chisq,'o'); hold on; plot(astats(:,7),[0 0 0],'r*');
vline(aa(7)); xlabel('ut');
subplot(2,4,8); cla;
plot(amc(:,8),chisq,'o'); hold on; plot(astats(:,8),[0 0 0],'r*');
vline(aa(8)); xlabel('vt');

% Tests of whether detranslating produces bias to high vmax

clear;
ut = 5; vt = -3;
aa = [75,25e3,2.3,93000,298,0,0,ut,vt]'; na = length(aa);
f = cor(15);
r = 1e3*[5 10 20:2:30  60:10:90]'; nr = length(r);
lam = 2*pi*rand(nr,1);
t = 1e4*rand(nr,1);
x = r.*cos(lam) + ut*t; y = r.*sin(lam) + vt*t; xyt = [ x y t ];

sig = 200*ones(nr,1);
rfit = 1e3*[1 : 120]'; drfit = rfit(2) - rfit(1);
ptrue = holland_p(rfit,aa);
penv = holland_p(1e6,aa);
vtrue = holland_v(rfit,aa,f);

nmc = 100;
amc = zeros(nmc,na);
chisq = zeros(nmc,1);
pomc = zeros(nmc,nr);
doplot = (nmc == 1);
for ii = 1 : nmc
   po = holland_p(r,aa); %  + sig.*randn(nr,1);
   xo = x + 1e3*randn(nr,1);
   yo = y + 1e3*randn(nr,1);
   pomc(ii,:) = po';
   a0 = aa;
   ia = [ 1 1 1 1 0 1 1 1 1 ]';  % don't fit Tbar

   [a,cov,chisq(ii)] = mrqmin_multi([xo yo t], po, sig, a0, ia, 'holland_p_xyuv', 100, 10);

   amc(ii,:) = a';

   pfit = holland_p(rfit,amc(ii,:)');
   vfit = holland_v(rfit,amc(ii,:)',f);
   ro = hypot(xo - ut*t, yo - vt*t);

   if doplot
      fig(1); clf;
      subplot(3,1,1); cla;
      plot(ro/1e3,pomc(ii,:)/1e2,'bo'); hold on; xlim(0,120); ylim(920,1010);
      plot(rfit/1e3,pfit/1e2,'r');
      plot(rfit/1e3,ptrue/1e2,'g-');
      subplot(3,1,2); cla;
      plot(rfit/1e3,(pfit-ptrue)/1e2,'r'); hold on; xlim(0,120);
      subplot(3,1,3); cla;
      plot(rfit/1e3,vfit,'r'); hold on; xlim(0,120); ylim(0,80);
      plot(rfit/1e3,vtrue,'g-');
      reltext(0.5,0.8,sprintf('vm true=%.1f fit=%.1f m/s',aa(1),amc(ii,1)));
   end
end

fig(2); clf;
subplot(2,4,1); cla;
plot(amc(:,1),chisq,'o'); hold on; plot(astats(:,1),[0 0 0],'r*');
xlabel('vm'); vline(aa(1)); ylabel('\chi^2');
subplot(2,4,2); cla;
plot(amc(:,2)/1e3,chisq,'o'); hold on; plot(astats(:,2)/1e3,[0 0 0],'r*');
vline(aa(2)/1e3); xlabel('rm');
subplot(2,4,3); cla;
plot(amc(:,3),chisq,'o'); hold on; plot(astats(:,3),[0 0 0],'r*');
vline(aa(3)); xlabel('b');
subplot(2,4,4); cla;
plot(amc(:,4)/1e2,chisq,'o'); hold on; plot(astats(:,4)/1e2,[0 0 0],'r*');
vline(aa(4)/1e2); xlabel('pc');
subplot(2,4,5); cla;
plot(amc(:,6),chisq,'o'); hold on; plot(astats(:,5),[0 0 0],'r*');
vline(aa(5)); xlabel('delx'); ylabel('\chi^2');
subplot(2,4,6); cla;
plot(amc(:,7),chisq,'o'); hold on; plot(astats(:,6),[0 0 0],'r*');
vline(aa(6)); xlabel('dely');
subplot(2,4,7); cla;
plot(amc(:,8),chisq,'o'); hold on; plot(astats(:,7),[0 0 0],'r*');
vline(aa(7)); xlabel('ut');
subplot(2,4,8); cla;
plot(amc(:,9),chisq,'o'); hold on; plot(astats(:,8),[0 0 0],'r*');
vline(aa(8)); xlabel('vt');



