% Initial simple test
nt = 50;
t = 100*[1 : nt]';
ut = 5; vt = -3;
x = 10e3*randn(nt,1);
y = 10e3*randn(nt,1);
xyt = [ x + ut*t, y + vt*t, t ];
       
uv = [ -y/1e3 , x/1e3 ];

[a,circ] = simplex_track(uv,xyt,[1e3 1e3 5 -2]');

% Test with Holland bogus winds
clear;
dx = 0; dy = 0; ut = 5; vt = 3;
aa = [dx,dy,ut,vt]'; na = length(aa);
f = cor(15); 
r = 1e3*[1 3 20:1:30  80:4:100]'; nr = length(r);
lam = 2*pi*rand(nr,1);
t = 3e4*( ([1 : nr]')/nr - 0.5 );
x = r.*cos(lam) + dx + ut*t; y = r.*sin(lam) + dy + vt*t; 
xyt = [ x, y, t ];
sig = 5*ones(nr,1); 
vobs  = holland_v(r, [50,25e3,1.3,95000,298]',f);
uxobs = -vobs.*sin(lam); vxobs = vobs.*cos(lam);
uv = [uxobs, vxobs];

[a,ccirc] = simplex_track(uv,xyt,[1e3 1e3 5 -2]');

nmc = 100; ii = 1;
amc = zeros(nmc,na);
circ = zeros(nmc,1);
vomc = zeros(nmc,nr,2);
doplot = (nmc == 1);
for ii = 1 : nmc
   uvo = [ uxobs + sig.*randn(nr,1), vxobs + sig.*randn(nr,1) ];
   vomc(ii,:,:) = uvo; % uvo = squeeze(vomc(ii,:,:));
   a0 = aa;

   [a,circ(ii)] = simplex_track(uvo,xyt,[1e3 1e3 4 -2]');
   amc(ii,:) = a';
   if doplot
      fig(1); clf;
      subplot(1,2,1); cla;
      x0 = x - a(1) - a(3)*t; y0 = y - a(2) - a(4)*t;
      quiver(x0,y0,uvo(:,1),uvo(:,2)); hold on;
      quiver(x0,y0,uv(:,1),uv(:,2),'g');
      set(gca,'DataAspectRatio',[1 1 1]); xylim(2e5);
      hline(0); vline(0);
      subplot(1,2,2); cla;
      quiver(x,y,uvo(:,1),uvo(:,2)); hold on;
      set(gca,'DataAspectRatio',[1 1 1]); xylim(2e5);
   end
end

bara = mean(amc); siga = std(amc);
astats = [ bara-siga ; bara ; bara+siga ];

fig(2); clf;
subplot(2,2,1); cla;
plot(amc(:,1),circ,'o'); vline(astats(:,1),'r'); 
xlabel('dx'); vline(aa(1)); hline(ccirc); ylabel('circ');
subplot(2,2,2); cla;
plot(amc(:,2),circ,'o'); vline(astats(:,2),'r'); 
xlabel('dy'); vline(aa(2)); hline(ccirc); 
subplot(2,2,3); cla;
plot(amc(:,3),circ,'o'); vline(astats(:,3),'r'); 
xlabel('ut'); vline(aa(3)); hline(ccirc); ylabel('circ');
subplot(2,2,4); cla;
plot(amc(:,4),circ,'o'); vline(astats(:,4),'r'); 
xlabel('vt'); vline(aa(4)); hline(ccirc); 
