% Check against willoughby_2_noblend etc
clear
a = [50 80e3 50e3 95000]';
a2 = [ a(1:2) ; 1e-6 ; 1e8 ; a(3:4) ];
dr = 2e2;
f = cor(15);
r = [0:dr:100e3]';
[p,dp] = willoughby1_p_noblend(r,a,f);
[p2,dp2] = willoughby2_p_noblend(r,a2,f);
fig(1); clf;
subplot(2,2,1); cla; plot(r/1e3,[p,p2]/1e2);
subplot(2,2,2); cla; plot(r/1e3,[dp(:,1),dp2(:,1)]);
subplot(2,2,3); cla; plot(r/1e3,[dp(:,2),dp2(:,2)]);
subplot(2,2,4); cla; plot(r/1e3,[dp(:,3),dp2(:,5)]);

p = willoughby1_p_numerical(r,a,f);
p2 = willoughby2_p_numerical(r,a2,f);
fig(1); clf; plot(r/1e3,[p,p2]/1e2);

% Test mrqmin fitting
clear;
aa = [50,50e3,22e3,95000]'; na = length(aa);
f = cor(15); rho = 1.15;
r = 1e3*[1 3 20:1:30  80:4:100]'; nr = length(r);
%r = 1e3*[1 3 20:1:30  80:4:100 200:100:1000]'; nr = length(r);
sig = 100*ones(nr,1); 
rfit = 1e3*[0 : 120]'; drfit = rfit(2) - rfit(1);
ptrue = willoughby1_p_numerical(rfit,aa,f);
penv = willoughby1_p_numerical(1e6,aa,f);
vtrue = willoughby1_v(rfit,aa);

nmc = 100;
vmfit = zeros(nmc,1); amc = zeros(nmc,na);
chisq = zeros(nmc,1); chisq1 = chisq;
pomc = zeros(nmc,nr);
doplot = 0;
for ii = 1 : nmc
   po = willoughby1_p_numerical(r,aa) + sig.*randn(nr,1);
   pomc(ii,:) = po';
   %a0 = aa .* (1 + 0.05*randn(size(aa))); a0(2) = 70e3;
   a0 = [50 70e3 25e3 95000]';
   dela = [5 5e3 1e3 1e3]';
   
   % Fudge to keep length scale  and rm under control
   r1 = [ r ; -999.0 ];
   po1 = [ po ; 0 ];
   sig1 = [ sig ; 1 ];
   
   [a1,cov,chisq1(ii)] = mrqmin(r1, po1, sig1, a0, 'willoughby1_p_noblend', 100, 2);
 % [a,cov,chisq(ii)] = mrqmin(r1, po1, sig1, a1,  'willoughby1_p_numerical', 100, 2);
   [a,chisq(ii),nf] = nlinfit_amoeba(r1, po1, sig1, a1, dela, 'willoughby1_p_numerical', 1e-3, 200);

   amc(ii,:) = a';
   
   pfit = willoughby1_p_numerical(rfit,amc(ii,:)');
   vfit = willoughby1_v(rfit,amc(ii,:)');
   
   if doplot
      fig(1); clf;
      subplot(3,1,1); cla;
      plot(r/1e3,pomc(ii,:)/1e2,'bo'); hold on; xlim(0,120); ylim(940,1010);
      plot(rfit/1e3,pfit/1e2,'r');
      plot(rfit/1e3,ptrue/1e2,'g-');
      subplot(3,1,2); cla;
      plot(rfit/1e3,(pfit-ptrue)/1e2,'r'); hold on; xlim(0,120);
      subplot(3,1,3); cla;
      plot(rfit/1e3,vfit,'r'); hold on; xlim(0,120); ylim(0,60);
      plot(rfit/1e3,vtrue,'g-');     
      reltext(0.5,0.8,sprintf('vm true=%.1f fit=%.1f m/s',aa(1),amc(ii,1)));
   end
end

save test_will1_p

fig(2); clf;
subplot(2,2,1); cla;
plot(amc(:,1),chisq,'o'); xlabel('vm'); vline(aa(1)); ylabel('\chi^2');
subplot(2,2,2); cla;
plot(amc(:,2)/1e3,chisq,'o'); vline(aa(2)/1e3); xlabel('L'); 
subplot(2,2,3); cla;
plot(amc(:,3)/1e3,chisq,'o'); vline(aa(3)/1e3); xlabel('rm');
subplot(2,2,4); cla;
plot(amc(:,4)/1e2,chisq,'o'); vline(aa(4)/1e2); xlabel('pc');

% Test for significance of fitting second exponential
clear;
aa = [30,50e3,20,300e3,22e3,95000]'; na = length(aa);
f = cor(15); rho = 1.15;
r = 1e3*[1 3 20:1:30  80:4:100 200:100:1000]'; nr = length(r);
%r = 1e3*[5:5:95]'; nr=length(r);
%r = 1e3*[1 3 20:1:30  80:4:100 200:100:1000]'; nr = length(r);
sig = 100*ones(nr,1); 
rfit = 1e3*[0 : 120]'; drfit = rfit(2) - rfit(1);
ptrue = willoughby2_p_numerical(rfit,aa,f);
penv = willoughby2_p_numerical(1e6,aa,f);
vtrue = willoughby2_v(rfit,aa);
vmtrue = aa(1) + aa(3);

po = willoughby2_p_numerical(r,aa);
a0 = [52 70e3 30e3 95000]';
dela = [5 5e3 1e3 1e3]';

% Fudge to keep length scale  and rm under control
if 1
   r1 = [ r ; -999.0 ]; po1 = [ po ; 0 ]; sig1 = [ sig ; 1 ];
else
   r1 = r; po1 = po; sig1 = sig;
end

[a1,cov,chisq1] = mrqmin(r1, po1, sig1, a0, 'willoughby1_p_noblend', 100, 2);
% [a,cov,chisq(ii)] = mrqmin(r1, po1, sig1, a1,  'willoughby1_p_numerical', 100, 2);
[a,chisq,nf] = nlinfit_amoeba(r1, po1, sig1, a1, dela, 'willoughby1_p_numerical', 1e-3, 200);

pfit = willoughby1_p_numerical(rfit,a);
vfit = willoughby1_v(rfit,a);

fig(1); clf;
subplot(3,1,1); cla;
plot(r/1e3,po/1e2,'bo'); hold on; xlim(0,120); ylim(940,1010);
plot(rfit/1e3,pfit/1e2,'r');
plot(rfit/1e3,ptrue/1e2,'g-');
subplot(3,1,2); cla;
plot(rfit/1e3,(pfit-ptrue)/1e2,'r'); hold on; xlim(0,120);
subplot(3,1,3); cla;
plot(rfit/1e3,vfit,'r'); hold on; xlim(0,120); ylim(0,60);
plot(rfit/1e3,vtrue,'g-');     
reltext(0.5,0.8,sprintf('vm true=%.1f fit=%.1f m/s',vmtrue,a(1)));

% Monte-Carlo fits of Willoughby1 profile to willoughby2 data
clear;
aa = [30,50e3,20,300e3,22e3,95000]'; na = length(aa);
f = cor(15); rho = 1.15;
r = 1e3*[1 3 20:1:30  80:4:100 200:100:1000]'; nr = length(r);
%r = 1e3*[5:5:95]'; nr=length(r);
%r = 1e3*[1 3 20:1:30  80:4:100 200:100:1000]'; nr = length(r);
sig = 100*ones(nr,1); 
rfit = 1e3*[0 : 120]'; drfit = rfit(2) - rfit(1);
ptrue = willoughby2_p_numerical(rfit,aa,f);
penv = willoughby2_p_numerical(1e6,aa,f);
vtrue = willoughby2_v(rfit,aa);
vmtrue = aa(1) + aa(3);

nmc = 100;
vmfit = zeros(nmc,1); amc = zeros(nmc,4);
chisq = zeros(nmc,1); chisq1 = chisq;
pomc = zeros(nmc,nr);
doplot = 0;
for ii = 1 : nmc
   po = willoughby2_p_numerical(r,aa) + sig.*randn(nr,1);
   pomc(ii,:) = po';
   %a0 = aa .* (1 + 0.05*randn(size(aa))); a0(2) = 70e3;
   a0 = [50 70e3 25e3 95000]';
   dela = [5 5e3 1e3 1e3]';
   
   % Fudge to keep length scale  and rm under control
   r1 = [ r ; -999.0 ];
   po1 = [ po ; 0 ];
   sig1 = [ sig ; 1 ];
   
   [a1,cov,chisq1(ii)] = mrqmin(r1, po1, sig1, a0, 'willoughby1_p_noblend', 100, 2);
 % [a,cov,chisq(ii)] = mrqmin(r1, po1, sig1, a1,  'willoughby1_p_numerical', 100, 2);
   [a,chisq(ii),nf] = nlinfit_amoeba(r1, po1, sig1, a1, dela, 'willoughby1_p_numerical', 1e-3, 200);

   amc(ii,:) = a';
   
   pfit = willoughby1_p_numerical(rfit,amc(ii,:)');
   vfit = willoughby1_v(rfit,amc(ii,:)');
   
   if doplot
      fig(1); clf;
      subplot(3,1,1); cla;
      plot(r/1e3,pomc(ii,:)/1e2,'bo'); hold on; xlim(0,120); ylim(940,1010);
      plot(rfit/1e3,pfit/1e2,'r');
      plot(rfit/1e3,ptrue/1e2,'g-');
      subplot(3,1,2); cla;
      plot(rfit/1e3,(pfit-ptrue)/1e2,'r'); hold on; xlim(0,120);
      subplot(3,1,3); cla;
      plot(rfit/1e3,vfit,'r'); hold on; xlim(0,120); ylim(0,60);
      plot(rfit/1e3,vtrue,'g-');     
      reltext(0.5,0.8,sprintf('vm true=%.1f fit=%.1f m/s',vmtrue,amc(ii,1)));
   end
end

save test_will12_p

fig(2); clf;
subplot(2,2,1); cla;
plot(amc(:,1),chisq,'o'); xlabel('vm'); vline(vmtrue); ylabel('\chi^2');
subplot(2,2,2); cla;
plot(amc(:,2)/1e3,chisq,'o'); xlabel('L'); 
subplot(2,2,3); cla;
plot(amc(:,3)/1e3,chisq,'o'); xlabel('rm');
subplot(2,2,4); cla;
plot(amc(:,4)/1e2,chisq,'o'); xlabel('pc');

