aa = [30,20e3,20,300e3,22e3 ]'; na = length(aa);
r = 1e3*[1 3 20:1:30  80:4:100]'; nr = length(r);
sig = 2*ones(nr,1); %sig(1:2) = 5;
rfit = 1e3*[0 : 120]'; drfit = rfit(2) - rfit(1);
vtrue = willoughby2_v(rfit,aa);
f = cor(15); rho = 1.15;
gwetrue = 0.01*rho*vtrue.*(vtrue./(rfit + 1e-30) + f); 
dptrue = sum(gwetrue)*drfit;

nmc = 100;
dpfit = zeros(nmc,1); amc = zeros(nmc,na);
chisq = zeros(nmc,1);
vomc = zeros(nmc,nr);
doplot = 0;
for ii = 1 : nmc
   vo = willoughby2_v(r,aa) + sig.*randn(nr,1);
   vomc(ii,:) = vo';
   
   % Fudge to keep length scale  and rm under control
   r1   = [ r; 1e6; 2e6; 1e7; -999 ];
   vo1  = [ vo; 1; 0; 0; 0 ];
   sig1 = [ sig; 2; 2; 2; 1 ];
   
   for it = 1 : 4
      a0 = aa .* (1 + 0.2*randn(size(aa)));
      [a,cov,chisq(ii)] = mrqmin(r1, vo1, sig1, a0, 'willoughby2_v');
      if chisq(ii) < 2, break; end
   end
   amc(ii,:) = a';
   
   vfit = willoughby2_v(rfit,amc(ii,:)');
   gwefit = 0.01*rho*vfit.*(vfit./(rfit + 1e-30) + f); 
   dpfit(ii) = sum(gwefit)*drfit;
   
   if doplot
      fig(1); clf;
      subplot(2,1,1); cla;
      plot(r/1e3,vomc(ii,:),'bo'); hold on; xlim(0,120); ylim(-10,60);
      plot(rfit/1e3,vfit,'r');
      plot(rfit/1e3,vtrue,'g-');
      subplot(2,1,2); cla;
      plot(rfit/1e3,gwefit,'r'); hold on; xlim(0,120);
      plot(rfit/1e3,gwetrue,'g-');
      reltext(0.5,0.8,sprintf('dp true=%.1f fit=%.1f hPa',dptrue,dpfit(ii)));
   end
end

fig(2); clf;
subplot(2,3,1); cla;
plot(dpfit,chisq,'o'); vline(dptrue); xlabel('dpfit'); ylabel('\chi^2');
subplot(2,3,2); cla;
plot(amc(:,1),chisq,'o'); vline(aa(1)); xlabel('A'); 
subplot(2,3,3); cla;
plot(amc(:,2)/1e3,chisq,'o'); vline(aa(2)/1e3); xlabel('L1'); 
subplot(2,3,4); cla;
plot(amc(:,3),chisq,'o'); vline(aa(3)); xlabel('B'); ylabel('\chi^2');
subplot(2,3,5); cla;
plot(amc(:,4)/1e3,chisq,'o'); vline(aa(4)/1e3); xlabel('L2');
subplot(2,3,6); cla;
plot(amc(:,5)/1e3,chisq,'o'); vline(aa(5)/1e3); xlabel('rm');


% Check derivatives 
a = [30 5e4 20 3e6 22e3 1 92000 298]';
r = [ 20e3 ];
for ii = 1 : 8
   del = 1e-06; 
   a1 = a; a1(ii) = a1(ii)*(1 + del);
   [p1,dp1] = willoughby2_v(r,a1);
   a0 = a; a0(ii) = a0(ii)*(1 - del);
   [p0,dp0] = willoughby2_v(r,a0);
   [p2,dp2] = willoughby2_v(r,a);
   disp(sprintf('%12.4e %12.4e',(p1 - p0)/(a1(ii) - a0(ii)), dp2(:,ii)));
end

% Check derivatives for version with constant blending zone
clear
clear global
global w2_fix_rblend
a = [30 5e4 20 3e6 22e3 1 92000 298]';
w2_fix_rblend = a(5) + 3e3;
r = [ 17e3 ];
for ii = 1 : 8
   del = 1e-06;
   a1 = a; a1(ii) = a1(ii)*(1 + del);
   [p1,dp1] = willoughby2_v_fixblend(r,a1);
   a0 = a; a0(ii) = a0(ii)*(1 - del);
   [p0,dp0] = willoughby2_v_fixblend(r,a0);
   [p2,dp2] = willoughby2_v_fixblend(r,a);
   d1 = (p1 - p0)/(a1(ii) - a0(ii));
   d2 = dp2(:,ii); 
   disp(sprintf('%12.4e %12.4e %2d', d1, d2, abs(d1-d2) <= 1e-6*max(abs(d1),abs(d2))));
end

